# coding: utf-8

"""
    Lex Machina API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 20250708
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from lexmachina.models.case_count_by_court import CaseCountByCourt
from typing import Optional, Set
from typing_extensions import Self

class BankruptcyJudgeData(BaseModel):
    """
    BankruptcyJudgeData
    """ # noqa: E501
    name: StrictStr
    bankruptcy_judge_id: StrictInt = Field(alias="bankruptcyJudgeId")
    initials: StrictStr
    case_count_by_court: List[CaseCountByCourt] = Field(alias="caseCountByCourt")
    __properties: ClassVar[List[str]] = ["name", "bankruptcyJudgeId", "initials", "caseCountByCourt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BankruptcyJudgeData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in case_count_by_court (list)
        _items = []
        if self.case_count_by_court:
            for _item_case_count_by_court in self.case_count_by_court:
                if _item_case_count_by_court:
                    _items.append(_item_case_count_by_court.to_dict())
            _dict['caseCountByCourt'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BankruptcyJudgeData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "bankruptcyJudgeId": obj.get("bankruptcyJudgeId"),
            "initials": obj.get("initials"),
            "caseCountByCourt": [CaseCountByCourt.from_dict(_item) for _item in obj["caseCountByCourt"]] if obj.get("caseCountByCourt") is not None else None
        })
        return _obj


