# coding: utf-8

"""
    Lex Machina API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 20250708
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from lexmachina.models.expert_witness import ExpertWitness
from lexmachina.models.judge import Judge
from typing import Optional, Set
from typing_extensions import Self

class ExpertWitnessAdmissibilityOrder(BaseModel):
    """
    ExpertWitnessAdmissibilityOrder
    """ # noqa: E501
    expert_witness: ExpertWitness = Field(alias="expertWitness")
    retaining_party_ids: List[StrictInt] = Field(alias="retainingPartyIds")
    opposing_party_ids: List[StrictInt] = Field(alias="opposingPartyIds")
    judge: Optional[Judge] = None
    docket_entry_filed: Optional[date] = Field(default=None, alias="docketEntryFiled")
    outcome: StrictStr
    occurred: date
    negated: Optional[date] = None
    reinstated: Optional[date] = None
    __properties: ClassVar[List[str]] = ["expertWitness", "retainingPartyIds", "opposingPartyIds", "judge", "docketEntryFiled", "outcome", "occurred", "negated", "reinstated"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpertWitnessAdmissibilityOrder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of expert_witness
        if self.expert_witness:
            _dict['expertWitness'] = self.expert_witness.to_dict()
        # override the default output from pydantic by calling `to_dict()` of judge
        if self.judge:
            _dict['judge'] = self.judge.to_dict()
        # set to None if judge (nullable) is None
        # and model_fields_set contains the field
        if self.judge is None and "judge" in self.model_fields_set:
            _dict['judge'] = None

        # set to None if docket_entry_filed (nullable) is None
        # and model_fields_set contains the field
        if self.docket_entry_filed is None and "docket_entry_filed" in self.model_fields_set:
            _dict['docketEntryFiled'] = None

        # set to None if negated (nullable) is None
        # and model_fields_set contains the field
        if self.negated is None and "negated" in self.model_fields_set:
            _dict['negated'] = None

        # set to None if reinstated (nullable) is None
        # and model_fields_set contains the field
        if self.reinstated is None and "reinstated" in self.model_fields_set:
            _dict['reinstated'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpertWitnessAdmissibilityOrder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "expertWitness": ExpertWitness.from_dict(obj["expertWitness"]) if obj.get("expertWitness") is not None else None,
            "retainingPartyIds": obj.get("retainingPartyIds"),
            "opposingPartyIds": obj.get("opposingPartyIds"),
            "judge": Judge.from_dict(obj["judge"]) if obj.get("judge") is not None else None,
            "docketEntryFiled": obj.get("docketEntryFiled"),
            "outcome": obj.get("outcome"),
            "occurred": obj.get("occurred"),
            "negated": obj.get("negated"),
            "reinstated": obj.get("reinstated")
        })
        return _obj


