# coding: utf-8

"""
    Lex Machina API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 20250708
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from lexmachina.models.judgment_event_filter import JudgmentEventFilter
from lexmachina.models.timing_filter import TimingFilter
from typing import Optional, Set
from typing_extensions import Self

class IndividualRulingsFilter(BaseModel):
    """
    IndividualRulingsFilter
    """ # noqa: E501
    judgment_event: Optional[JudgmentEventFilter] = Field(default=None, alias="judgmentEvent")
    awarded_to_parties: Optional[List[StrictInt]] = Field(default=None, alias="awardedToParties")
    awarded_against_parties: Optional[List[StrictInt]] = Field(default=None, alias="awardedAgainstParties")
    var_date: Optional[TimingFilter] = Field(default=None, alias="date")
    __properties: ClassVar[List[str]] = ["judgmentEvent", "awardedToParties", "awardedAgainstParties", "date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IndividualRulingsFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of judgment_event
        if self.judgment_event:
            _dict['judgmentEvent'] = self.judgment_event.to_dict()
        # override the default output from pydantic by calling `to_dict()` of var_date
        if self.var_date:
            _dict['date'] = self.var_date.to_dict()
        # set to None if judgment_event (nullable) is None
        # and model_fields_set contains the field
        if self.judgment_event is None and "judgment_event" in self.model_fields_set:
            _dict['judgmentEvent'] = None

        # set to None if awarded_to_parties (nullable) is None
        # and model_fields_set contains the field
        if self.awarded_to_parties is None and "awarded_to_parties" in self.model_fields_set:
            _dict['awardedToParties'] = None

        # set to None if awarded_against_parties (nullable) is None
        # and model_fields_set contains the field
        if self.awarded_against_parties is None and "awarded_against_parties" in self.model_fields_set:
            _dict['awardedAgainstParties'] = None

        # set to None if var_date (nullable) is None
        # and model_fields_set contains the field
        if self.var_date is None and "var_date" in self.model_fields_set:
            _dict['date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IndividualRulingsFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "judgmentEvent": JudgmentEventFilter.from_dict(obj["judgmentEvent"]) if obj.get("judgmentEvent") is not None else None,
            "awardedToParties": obj.get("awardedToParties"),
            "awardedAgainstParties": obj.get("awardedAgainstParties"),
            "date": TimingFilter.from_dict(obj["date"]) if obj.get("date") is not None else None
        })
        return _obj


