# coding: utf-8

"""
    Lex Machina API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 20250708
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from lexmachina.models.bankruptcy_judge_result import BankruptcyJudgeResult
from lexmachina.models.federal_judge_result import FederalJudgeResult
from lexmachina.models.magistrate_judge_result import MagistrateJudgeResult
from lexmachina.models.state_judge_result import StateJudgeResult
from typing import Optional, Set
from typing_extensions import Self

class JudgeSearchResult(BaseModel):
    """
    JudgeSearchResult
    """ # noqa: E501
    federal_judges: List[FederalJudgeResult] = Field(alias="federalJudges")
    magistrate_judges: List[MagistrateJudgeResult] = Field(alias="magistrateJudges")
    state_judges: List[StateJudgeResult] = Field(alias="stateJudges")
    bankruptcy_judges: List[BankruptcyJudgeResult] = Field(alias="bankruptcyJudges")
    __properties: ClassVar[List[str]] = ["federalJudges", "magistrateJudges", "stateJudges", "bankruptcyJudges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JudgeSearchResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in federal_judges (list)
        _items = []
        if self.federal_judges:
            for _item_federal_judges in self.federal_judges:
                if _item_federal_judges:
                    _items.append(_item_federal_judges.to_dict())
            _dict['federalJudges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in magistrate_judges (list)
        _items = []
        if self.magistrate_judges:
            for _item_magistrate_judges in self.magistrate_judges:
                if _item_magistrate_judges:
                    _items.append(_item_magistrate_judges.to_dict())
            _dict['magistrateJudges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in state_judges (list)
        _items = []
        if self.state_judges:
            for _item_state_judges in self.state_judges:
                if _item_state_judges:
                    _items.append(_item_state_judges.to_dict())
            _dict['stateJudges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in bankruptcy_judges (list)
        _items = []
        if self.bankruptcy_judges:
            for _item_bankruptcy_judges in self.bankruptcy_judges:
                if _item_bankruptcy_judges:
                    _items.append(_item_bankruptcy_judges.to_dict())
            _dict['bankruptcyJudges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JudgeSearchResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "federalJudges": [FederalJudgeResult.from_dict(_item) for _item in obj["federalJudges"]] if obj.get("federalJudges") is not None else None,
            "magistrateJudges": [MagistrateJudgeResult.from_dict(_item) for _item in obj["magistrateJudges"]] if obj.get("magistrateJudges") is not None else None,
            "stateJudges": [StateJudgeResult.from_dict(_item) for _item in obj["stateJudges"]] if obj.get("stateJudges") is not None else None,
            "bankruptcyJudges": [BankruptcyJudgeResult.from_dict(_item) for _item in obj["bankruptcyJudges"]] if obj.get("bankruptcyJudges") is not None else None
        })
        return _obj


